﻿using Google.Protobuf.WellKnownTypes;

using Grpc.Core;
using Grpc.Net.Client;

using TestClient;

using var channel = GrpcChannel.ForAddress("http://localhost:5038");

var client = new WeatherForecastProto.WeatherForecastProtoClient(channel);

var cts = new CancellationTokenSource(TimeSpan.FromSeconds(5));

using var weatherCall = client.GetWeatherStream(new Empty(), cancellationToken : cts.Token);

try
{
    await foreach(WeatherForecastModel weatherForecast in weatherCall.ResponseStream.ReadAllAsync(cancellationToken : cts.Token))
    {
        Console.WriteLine($"{weatherForecast.DateTimeStamp.ToDateTime():s} | {weatherForecast.Summary} | {weatherForecast.TemperatureC} C");
    }
}
catch(RpcException exception) when (exception.StatusCode == StatusCode.Cancelled)
{
    Console.WriteLine("스트리밍 취소.");
}